#ifndef ET131X_PHY_H
#define ET131X_PHY_H

#include <linux/netdevice.h>

#include "et131x.h"


extern int et131x_mdio_read(struct net_device *netdev, int addr, int reg);
extern void et131x_mdio_write(struct net_device *netdev, int addr, int reg, int value);
extern int et131x_xcvr_find(struct et131x *et131x);
extern void et131x_phy_reset(struct et131x *et131x);
extern void et131x_phy_power(struct et131x *et131x, int enable);
extern void et131x_phy_autoneg(struct et131x *et131x, int enable);
extern void et131x_phy_duplex_mode(struct et131x *et131x, int fullduplex);
extern void et131x_phy_speed(struct et131x *et131x, int speed);
extern void et131x_phy_advertise_1000(struct et131x *et131x, int halfduplex, int fullduplex);
extern void et131x_phy_advertise_100(struct et131x *et131x, int halfduplex, int fullduplex);
extern void et131x_phy_advertise_10(struct et131x *et131x, int halfduplex, int fullduplex);
extern void et131x_phy_linkstatus(struct et131x *et131x, int *linkstatus, int *autoneg, int *linkspeed, int *duplex, int *mdimix, int *master, int *polarity);
extern int et131x_xcvr_init(struct et131x *et131x);
extern void et131x_phy_init(struct et131x *et131x);
extern int et131x_setphy_normal(struct et131x *et131x);


#endif
