#include <linux/config.h>
#include <linux/module.h>
#include <linux/init.h>
#include <linux/types.h>
#include <linux/kernel.h>
#include <linux/errno.h>
#include <linux/pci.h>
#include <linux/etherdevice.h>

#include "et131x.h"

int et131x_net_open(struct net_device *netdev) {
	netif_start_queue(netdev);
	return 0;
}

int et131x_net_close(struct net_device *netdev) {
	netif_stop_queue(netdev);
	return 0;
}

int et131x_net_xmit(struct sk_buff *skb, struct net_device *netdev) {
	struct et131x *et131x = netdev_priv(netdev);

	printk(KERN_DEBUG "et131x: transmitting packet to /dev/null\n");
	kfree_skb(skb);
	et131x->stats.tx_dropped++;
	return 0;
}

struct net_device_stats *et131x_net_stats(struct net_device *netdev) {
	struct et131x *et131x = netdev_priv(netdev);
	return &et131x->stats;
}
