#ifndef __PCAN_USB_KERNEL_H__
#define __PCAN_USB_KERNEL_H__
//****************************************************************************
// Copyright (C) 2001-2006  PEAK System-Technik GmbH
//
// linux@peak-system.com
// www.peak-system.com
//
// This part of software is proprietary
// No warranty is given at all 
//
// Maintainer(s): Klaus Hitschler (klaus.hitschler@gmx.de)
//****************************************************************************

//****************************************************************************
//
// pcan_usb-kernel.h - the inner hidden usb parts header for pcan-usb support
//
// $Id: pcan_usb_kernel.h 360 2006-02-05 10:49:18Z klaus $
//
//****************************************************************************


//****************************************************************************
// DEFINES

//****************************************************************************
// INCLUDES
#include <linux/types.h>
#include <linux/usb.h>

#include <src/pcan_main.h>

#ifdef LINUX_26
  #define __usb_submit_urb(x) usb_submit_urb(x, GFP_ATOMIC)
  #define __usb_alloc_urb(x)  usb_alloc_urb(x, GFP_ATOMIC)
  #define FILL_BULK_URB(a, b, c, d, e, f, g) usb_fill_bulk_urb(a, b, c, d, e, (usb_complete_t)f, (void *)g)
#else
  #define __usb_submit_urb(x) usb_submit_urb(x)
  #define __usb_alloc_urb(x)  usb_alloc_urb(x)
#endif

//****************************************************************************
// DEFINES
int pcan_hw_SetCANOn(struct pcandev *dev);
int pcan_hw_SetCANOff(struct pcandev *dev);

int pcan_hw_Init(struct pcandev *dev, u16 btr0btr1, u8 bListenOnly);
int pcan_hw_getSNR(struct pcandev *dev, u32 *pdwSNR);

int pcan_hw_DecodeMessage(struct pcandev *dev, u8 *ucMsgPtr, int lCurrentLength);
int pcan_hw_EncodeMessage(struct pcandev *dev, u8 *ucMsgPtr, int *pnDataLength);

int pcan_X(void);

#endif // __PCAN_USB_KERNEL_H__

